Skip to content
Get started

List objective tool calls

GET/v1/objectives/{objectiveId}/tool_calls

Lists all tool calls for an objective

Path ParametersExpand Collapse
objectiveId: string
Query ParametersExpand Collapse
cursor: optional string

Pagination cursor from previous response

includeInfo: optional boolean

When set to true you may use more of your alloted API rate-limit

limit: optional number

Maximum number of results to return

formatint32
status: optional "TOOL_CALL_STATUS_UNSPECIFIED" or "TOOL_CALL_STATUS_AUTO_APPROVED" or "TOOL_CALL_STATUS_WAITING_FOR_APPROVAL" or 2 more

Filter by tool call status

formatenum
One of the following:
"TOOL_CALL_STATUS_UNSPECIFIED"
"TOOL_CALL_STATUS_AUTO_APPROVED"
"TOOL_CALL_STATUS_WAITING_FOR_APPROVAL"
"TOOL_CALL_STATUS_APPROVED"
"TOOL_CALL_STATUS_DENIED"
ReturnsExpand Collapse
items: optional array of ObjectiveToolCall { data, metadata, status, 2 more }
data: ObjectiveToolCallData { callable, arguments, memo, 2 more }
callable: CallableTool { agent, cadenyaProvidedTool, tool }

CallableTool is a union that represents a tool that can be called by an agent. In Cadenya, a tool that is used within an agent objective might be a user-defined tool (IE: MCP, HTTP), another Agent (useful to separate context), or a Cadenya Tool (one Cadenya provides).

agent: optional ResourceMetadata { id, accountId, createdAt, 5 more }

Standard metadata for persistent, named resources (e.g., agents, tools, prompts)

id: string

Unique identifier for the resource (prefixed ULID, e.g., "agent_01HXK...")

accountId: string

Account this resource belongs to for multi-tenant isolation (prefixed ULID)

createdAt: string

Timestamp when this resource was created

formatdate-time
name: string

Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly

profileId: string

ID of the actor (user or service account) that created this resource

workspaceId: string

Workspace this resource belongs to for organizational grouping (prefixed ULID)

externalId: optional string

External ID for the resource (e.g., a workflow ID from an external system)

labels: optional map[string]

Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"}

cadenyaProvidedTool: optional ResourceMetadata { id, accountId, createdAt, 5 more }

Standard metadata for persistent, named resources (e.g., agents, tools, prompts)

id: string

Unique identifier for the resource (prefixed ULID, e.g., "agent_01HXK...")

accountId: string

Account this resource belongs to for multi-tenant isolation (prefixed ULID)

createdAt: string

Timestamp when this resource was created

formatdate-time
name: string

Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly

profileId: string

ID of the actor (user or service account) that created this resource

workspaceId: string

Workspace this resource belongs to for organizational grouping (prefixed ULID)

externalId: optional string

External ID for the resource (e.g., a workflow ID from an external system)

labels: optional map[string]

Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"}

tool: optional ResourceMetadata { id, accountId, createdAt, 5 more }

Standard metadata for persistent, named resources (e.g., agents, tools, prompts)

id: string

Unique identifier for the resource (prefixed ULID, e.g., "agent_01HXK...")

accountId: string

Account this resource belongs to for multi-tenant isolation (prefixed ULID)

createdAt: string

Timestamp when this resource was created

formatdate-time
name: string

Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly

profileId: string

ID of the actor (user or service account) that created this resource

workspaceId: string

Workspace this resource belongs to for organizational grouping (prefixed ULID)

externalId: optional string

External ID for the resource (e.g., a workflow ID from an external system)

labels: optional map[string]

Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"}

arguments: optional map[unknown]

The arguments passed to the tool

memo: optional string

A memo supplied by the reviewer when denying the tool call

result: optional string

The result content returned by the tool after execution

statusChangedBy: optional Profile { metadata, spec }

Profile represents a human user at the account level. Profiles are account-scoped resources that can be associated with multiple workspaces through the Actor model. Authentication for profiles is handled via SSO/OAuth (WorkOS).

metadata: AccountResourceMetadata { id, accountId, name, 3 more }

AccountResourceMetadata is used to represent a resource that is associated to an account but not to a workspace.

id: string

Unique identifier for the resource (prefixed ULID, e.g., "apikey_01HXK...")

accountId: string

Account this resource belongs to for multi-tenant isolation (prefixed ULID)

name: string

Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly

profileId: string
externalId: optional string

External ID for the resource (e.g., a workflow ID from an external system)

labels: optional map[string]

Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"}

spec: ProfileSpec { type, email, name }

ProfileSpec contains the profile-specific fields

type: "PROFILE_TYPE_USER" or "PROFILE_TYPE_API_KEY" or "PROFILE_TYPE_SYSTEM"

Type is the type of profile. User's are humans, API keys are computers. You know the deal.

formatenum
One of the following:
"PROFILE_TYPE_USER"
"PROFILE_TYPE_API_KEY"
"PROFILE_TYPE_SYSTEM"
email: optional string

Email address of the user (required, unique per account)

name: optional string

Display name for the user (e.g., "Bobby Tables")

metadata: OperationMetadata { id, accountId, createdAt, 4 more }

Metadata for ephemeral operations and activities (e.g., objectives, executions, runs)

id: string

Unique identifier for the operation (prefixed ULID, e.g., "obj_01HXK...")

accountId: string

Account this operation belongs to for multi-tenant isolation (prefixed ULID)

createdAt: string

Timestamp when this operation was created ULID includes timestamp information, but this explicit field enables easier querying

formatdate-time
profileId: string

ID of the actor (user or service account) that created this operation

workspaceId: string

Workspace this operation belongs to for organizational grouping (prefixed ULID)

externalId: optional string

External ID for the operation (e.g., a workflow ID from an external system)

labels: optional map[string]

Arbitrary key-value pairs for categorization and filtering Examples: {"priority": "high", "source": "api", "workflow": "onboarding"}

status: "TOOL_CALL_STATUS_UNSPECIFIED" or "TOOL_CALL_STATUS_AUTO_APPROVED" or "TOOL_CALL_STATUS_WAITING_FOR_APPROVAL" or 2 more

Current status of the tool call

formatenum
One of the following:
"TOOL_CALL_STATUS_UNSPECIFIED"
"TOOL_CALL_STATUS_AUTO_APPROVED"
"TOOL_CALL_STATUS_WAITING_FOR_APPROVAL"
"TOOL_CALL_STATUS_APPROVED"
"TOOL_CALL_STATUS_DENIED"
executionStatus: optional "TOOL_CALL_EXECUTION_STATUS_UNSPECIFIED" or "TOOL_CALL_EXECUTION_STATUS_PENDING" or "TOOL_CALL_EXECUTION_STATUS_RUNNING" or 2 more
formatenum
One of the following:
"TOOL_CALL_EXECUTION_STATUS_UNSPECIFIED"
"TOOL_CALL_EXECUTION_STATUS_PENDING"
"TOOL_CALL_EXECUTION_STATUS_RUNNING"
"TOOL_CALL_EXECUTION_STATUS_COMPLETED"
"TOOL_CALL_EXECUTION_STATUS_ERRORED"
info: optional ObjectiveToolCallInfo { createdBy, objective }
createdBy: optional Profile { metadata, spec }

Profile represents a human user at the account level. Profiles are account-scoped resources that can be associated with multiple workspaces through the Actor model. Authentication for profiles is handled via SSO/OAuth (WorkOS).

metadata: AccountResourceMetadata { id, accountId, name, 3 more }

AccountResourceMetadata is used to represent a resource that is associated to an account but not to a workspace.

id: string

Unique identifier for the resource (prefixed ULID, e.g., "apikey_01HXK...")

accountId: string

Account this resource belongs to for multi-tenant isolation (prefixed ULID)

name: string

Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly

profileId: string
externalId: optional string

External ID for the resource (e.g., a workflow ID from an external system)

labels: optional map[string]

Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"}

spec: ProfileSpec { type, email, name }

ProfileSpec contains the profile-specific fields

type: "PROFILE_TYPE_USER" or "PROFILE_TYPE_API_KEY" or "PROFILE_TYPE_SYSTEM"

Type is the type of profile. User's are humans, API keys are computers. You know the deal.

formatenum
One of the following:
"PROFILE_TYPE_USER"
"PROFILE_TYPE_API_KEY"
"PROFILE_TYPE_SYSTEM"
email: optional string

Email address of the user (required, unique per account)

name: optional string

Display name for the user (e.g., "Bobby Tables")

objective: optional OperationMetadata { id, accountId, createdAt, 4 more }

Metadata for ephemeral operations and activities (e.g., objectives, executions, runs)

id: string

Unique identifier for the operation (prefixed ULID, e.g., "obj_01HXK...")

accountId: string

Account this operation belongs to for multi-tenant isolation (prefixed ULID)

createdAt: string

Timestamp when this operation was created ULID includes timestamp information, but this explicit field enables easier querying

formatdate-time
profileId: string

ID of the actor (user or service account) that created this operation

workspaceId: string

Workspace this operation belongs to for organizational grouping (prefixed ULID)

externalId: optional string

External ID for the operation (e.g., a workflow ID from an external system)

labels: optional map[string]

Arbitrary key-value pairs for categorization and filtering Examples: {"priority": "high", "source": "api", "workflow": "onboarding"}

List objective tool calls

curl https://api.cadenya.com/v1/objectives/$OBJECTIVE_ID/tool_calls \
    -H "Authorization: Bearer $CADENYA_API_KEY"
{
  "items": [
    {
      "data": {
        "callable": {
          "agent": {
            "id": "id",
            "accountId": "accountId",
            "createdAt": "2019-12-27T18:11:19.117Z",
            "name": "name",
            "profileId": "profileId",
            "workspaceId": "workspaceId",
            "externalId": "externalId",
            "labels": {
              "foo": "string"
            }
          },
          "cadenyaProvidedTool": {
            "id": "id",
            "accountId": "accountId",
            "createdAt": "2019-12-27T18:11:19.117Z",
            "name": "name",
            "profileId": "profileId",
            "workspaceId": "workspaceId",
            "externalId": "externalId",
            "labels": {
              "foo": "string"
            }
          },
          "tool": {
            "id": "id",
            "accountId": "accountId",
            "createdAt": "2019-12-27T18:11:19.117Z",
            "name": "name",
            "profileId": "profileId",
            "workspaceId": "workspaceId",
            "externalId": "externalId",
            "labels": {
              "foo": "string"
            }
          }
        },
        "arguments": {
          "foo": "bar"
        },
        "memo": "memo",
        "result": "result",
        "statusChangedBy": {
          "metadata": {
            "id": "id",
            "accountId": "accountId",
            "name": "name",
            "profileId": "profileId",
            "externalId": "externalId",
            "labels": {
              "foo": "string"
            }
          },
          "spec": {
            "type": "PROFILE_TYPE_USER",
            "email": "email",
            "name": "name"
          }
        }
      },
      "metadata": {
        "id": "id",
        "accountId": "accountId",
        "createdAt": "2019-12-27T18:11:19.117Z",
        "profileId": "profileId",
        "workspaceId": "workspaceId",
        "externalId": "externalId",
        "labels": {
          "foo": "string"
        }
      },
      "status": "TOOL_CALL_STATUS_UNSPECIFIED",
      "executionStatus": "TOOL_CALL_EXECUTION_STATUS_UNSPECIFIED",
      "info": {
        "createdBy": {
          "metadata": {
            "id": "id",
            "accountId": "accountId",
            "name": "name",
            "profileId": "profileId",
            "externalId": "externalId",
            "labels": {
              "foo": "string"
            }
          },
          "spec": {
            "type": "PROFILE_TYPE_USER",
            "email": "email",
            "name": "name"
          }
        },
        "objective": {
          "id": "id",
          "accountId": "accountId",
          "createdAt": "2019-12-27T18:11:19.117Z",
          "profileId": "profileId",
          "workspaceId": "workspaceId",
          "externalId": "externalId",
          "labels": {
            "foo": "string"
          }
        }
      }
    }
  ],
  "pagination": {
    "nextCursor": "nextCursor",
    "total": 0
  }
}
Returns Examples
{
  "items": [
    {
      "data": {
        "callable": {
          "agent": {
            "id": "id",
            "accountId": "accountId",
            "createdAt": "2019-12-27T18:11:19.117Z",
            "name": "name",
            "profileId": "profileId",
            "workspaceId": "workspaceId",
            "externalId": "externalId",
            "labels": {
              "foo": "string"
            }
          },
          "cadenyaProvidedTool": {
            "id": "id",
            "accountId": "accountId",
            "createdAt": "2019-12-27T18:11:19.117Z",
            "name": "name",
            "profileId": "profileId",
            "workspaceId": "workspaceId",
            "externalId": "externalId",
            "labels": {
              "foo": "string"
            }
          },
          "tool": {
            "id": "id",
            "accountId": "accountId",
            "createdAt": "2019-12-27T18:11:19.117Z",
            "name": "name",
            "profileId": "profileId",
            "workspaceId": "workspaceId",
            "externalId": "externalId",
            "labels": {
              "foo": "string"
            }
          }
        },
        "arguments": {
          "foo": "bar"
        },
        "memo": "memo",
        "result": "result",
        "statusChangedBy": {
          "metadata": {
            "id": "id",
            "accountId": "accountId",
            "name": "name",
            "profileId": "profileId",
            "externalId": "externalId",
            "labels": {
              "foo": "string"
            }
          },
          "spec": {
            "type": "PROFILE_TYPE_USER",
            "email": "email",
            "name": "name"
          }
        }
      },
      "metadata": {
        "id": "id",
        "accountId": "accountId",
        "createdAt": "2019-12-27T18:11:19.117Z",
        "profileId": "profileId",
        "workspaceId": "workspaceId",
        "externalId": "externalId",
        "labels": {
          "foo": "string"
        }
      },
      "status": "TOOL_CALL_STATUS_UNSPECIFIED",
      "executionStatus": "TOOL_CALL_EXECUTION_STATUS_UNSPECIFIED",
      "info": {
        "createdBy": {
          "metadata": {
            "id": "id",
            "accountId": "accountId",
            "name": "name",
            "profileId": "profileId",
            "externalId": "externalId",
            "labels": {
              "foo": "string"
            }
          },
          "spec": {
            "type": "PROFILE_TYPE_USER",
            "email": "email",
            "name": "name"
          }
        },
        "objective": {
          "id": "id",
          "accountId": "accountId",
          "createdAt": "2019-12-27T18:11:19.117Z",
          "profileId": "profileId",
          "workspaceId": "workspaceId",
          "externalId": "externalId",
          "labels": {
            "foo": "string"
          }
        }
      }
    }
  ],
  "pagination": {
    "nextCursor": "nextCursor",
    "total": 0
  }
}